# Title: JoinStateSoilsData
# Description: Prepare new state SSURGO data for use by batch CADA model
# Software Requirements: ArcGIS 10, Spatial Analyst Extension
# Original Authors: Jeremy Hatfield, Robert Coville
# Last Edited by Original Authors: Summer 2018
#===============================================================================

import os
import arcinfo, os
import shutil
import csv
from arcpy.sa import *
from arcpy import *
from arcpy.analysis import *
from arcpy.management import *
arcpy.CheckOutExtension("Spatial")
env.overwriteOutput = True
path = os.getcwd()
soilpath = path+'\\NewStatesSoils\\'
#Rename downloaded soil folder by Two letter state abbreviation.
#Data from: WHO Knows
states = [fol for fol in os.listdir(soilpath) if len(fol) ==2]

for s in states: # for state in states
    print s
    dct={}
    for fil in os.listdir(os.path.join(soilpath,s)):
        if '.gdb' in fil and str(s) in fil:
            gdb = os.path.join(soilpath,s,fil) #find gdb file
            for p, d, q in arcpy.da.Walk(gdb): 
                for fil in q: #for file in gdb
                    if fil == 'MUPOLYGON':
                        dct['Shape'] = os.path.join(gdb,fil)
                    if fil=='component':
                        dct['Common'] = os.path.join(gdb,fil)
                    if fil == 'chorizon':                                    
                        dct['KSat'] = os.path.join(gdb,fil)
                    if fil == 'cosoilmoist':
                        dct['Depth'] = os.path.join(gdb,fil)
                    if fil =='comonth':
                        dct['DCommon']=os.path.join(gdb,fil)
    print dct
    inter = JoinField_management(dct['DCommon'],'comonthkey',dct['Depth'], "comonthkey")
    JoinField_management(dct['Common'],'cokey',inter, "cokey")
    JoinField_management(dct['Common'],'cokey',dct['KSat'], "cokey")
    #join fields in different tables using common keys to make one final table to pull from
    print 'Join Done'
